Index: /palm/trunk/SOURCE/transpose.f90
===================================================================
--- /palm/trunk/SOURCE/transpose.f90	(revision 1319)
+++ /palm/trunk/SOURCE/transpose.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -55,27 +61,4 @@
 ! indices nxa, nya, etc. replaced by nx, ny, etc.
 !
-! 683 2011-02-09 14:25:15Z raasch
-! openMP parallelization of transpositions for 2d-domain-decomposition
-!
-! 622 2010-12-10 08:08:13Z raasch
-! optional barriers included in order to speed up collective operations
-!
-! 164 2008-05-15 08:46:15Z raasch
-! f_inv changed from subroutine argument to automatic array in order to do
-! re-ordering from f_in to f_inv in one step, one array work is needed instead
-! of work1 and work2
-!
-! February 2007
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.2  2004/04/30 13:12:17  raasch
-! Switched from mpi_alltoallv to the simpler mpi_alltoall,
-! all former transpose-routine files collected in this file, enlarged
-! transposition arrays introduced
-!
-! Revision 1.1  2004/04/30 13:08:16  raasch
-! Initial revision (collection of former routines transpose_xy, transpose_xz,
-!                   transpose_yx, transpose_yz, transpose_zx, transpose_zy)
-!
 ! Revision 1.1  1997/07/24 11:25:18  raasch
 ! Initial revision
@@ -88,15 +71,21 @@
 !------------------------------------------------------------------------------!
 
-     USE indices
-     USE transpose_indices
+     USE indices,                                                              &
+         ONLY:  nx
+
+     USE kinds
+
+     USE transpose_indices,                                                    &
+         ONLY:  nxl_z, nxr_z, nyn_x, nyn_z, nys_x, nys_z, nzb_x, nzt_x
 
      IMPLICIT NONE
 
-     REAL ::  f_in(0:nx,nys_x:nyn_x,nzb_x:nzt_x)
-     REAL ::  f_inv(nys_x:nyn_x,nzb_x:nzt_x,0:nx)
-
-
-     INTEGER ::  i, j, k
-
+     REAL(wp) ::  f_in(0:nx,nys_x:nyn_x,nzb_x:nzt_x)  !: 
+     REAL(wp) ::  f_inv(nys_x:nyn_x,nzb_x:nzt_x,0:nx) !: 
+
+
+     INTEGER(iwp) ::  i !: 
+     INTEGER(iwp) ::  j !: 
+     INTEGER(iwp) ::  k !: 
 !
 !-- Rearrange indices of input array in order to make data to be send
@@ -128,16 +117,29 @@
 !------------------------------------------------------------------------------!
 
-    USE cpulog
-    USE indices
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, cpu_log_nowait, log_point_s
+
+    USE indices,                                                               &
+        ONLY:  nx, ny
+        
+    USE kinds
+
     USE pegrid
-    USE transpose_indices
+
+    USE transpose_indices,                                                     &
+        ONLY:  nxl_y, nxr_y, nyn_x, nys_x, nzb_x, nzb_y, nzt_x, nzt_y
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, l, ys
-    
-    REAL ::  f_inv(nys_x:nyn_x,nzb_x:nzt_x,0:nx), f_out(0:ny,nxl_y:nxr_y,nzb_y:nzt_y)
-
-    REAL, DIMENSION(nyn_x-nys_x+1,nzb_y:nzt_y,nxl_y:nxr_y,0:pdims(2)-1) ::  work
+    INTEGER(iwp) ::  i  !: 
+    INTEGER(iwp) ::  j  !: 
+    INTEGER(iwp) ::  k  !: 
+    INTEGER(iwp) ::  l  !: 
+    INTEGER(iwp) ::  ys !: 
+ 
+    REAL(wp) ::  f_inv(nys_x:nyn_x,nzb_x:nzt_x,0:nx) !: 
+    REAL(wp) ::  f_out(0:ny,nxl_y:nxr_y,nzb_y:nzt_y) !: 
+
+    REAL(wp), DIMENSION(nyn_x-nys_x+1,nzb_y:nzt_y,nxl_y:nxr_y,0:pdims(2)-1) ::  work !: 
 
 
@@ -207,15 +209,17 @@
 !------------------------------------------------------------------------------!
 
-     USE indices
-     USE transpose_indices
+     USE indices,                                                              &
+         ONLY:  nxl, nxr, nyn, nys, nz
+
+     USE kinds
 
      IMPLICIT NONE
 
-     REAL ::  f_inv(nys:nyn,nxl:nxr,1:nz)
-     REAL ::  f_out(1:nz,nys:nyn,nxl:nxr)
-
-
-     INTEGER ::  i, j, k
-
+     REAL(wp) ::  f_inv(nys:nyn,nxl:nxr,1:nz) !: 
+     REAL(wp) ::  f_out(1:nz,nys:nyn,nxl:nxr) !: 
+
+     INTEGER(iwp) ::  i !: 
+     INTEGER(iwp) ::  j !: 
+     INTEGER(iwp) ::  k !: 
 !
 !-- Rearrange indices of input array in order to make data to be send
@@ -249,16 +253,31 @@
 !------------------------------------------------------------------------------!
 
-    USE cpulog
-    USE indices
-    USE pegrid
-    USE transpose_indices
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, cpu_log_nowait, log_point_s
+
+    USE indices,                                                               &
+        ONLY:  nnx, nx, nxl, nxr, ny, nyn, nys, nz
+
+    USE kinds
+
+    USE pegrid,                                                                &
+        ONLY:  collective_wait, comm1dx, comm2d, ierr, MPI_DOUBLE_PRECISION,   &
+               pdims, sendrecvcount_zx
+
+    USE transpose_indices,                                                     &
+        ONLY:  nyn_x, nys_x, nzb_x, nzt_x
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, l, xs
-    
-    REAL ::  f_in(0:nx,nys_x:nyn_x,nzb_x:nzt_x), f_inv(nys:nyn,nxl:nxr,1:nz)
-
-    REAL, DIMENSION(nys_x:nyn_x,nnx,nzb_x:nzt_x,0:pdims(1)-1) ::  work
+    INTEGER(iwp) ::  i  !: 
+    INTEGER(iwp) ::  j  !: 
+    INTEGER(iwp) ::  k  !: 
+    INTEGER(iwp) ::  l  !: 
+    INTEGER(iwp) ::  xs !: 
+
+    REAL(wp) ::  f_in(0:nx,nys_x:nyn_x,nzb_x:nzt_x) !: 
+    REAL(wp) ::  f_inv(nys:nyn,nxl:nxr,1:nz) !: 
+
+    REAL(wp), DIMENSION(nys_x:nyn_x,nnx,nzb_x:nzt_x,0:pdims(1)-1) ::  work !: 
 
 
@@ -331,15 +350,21 @@
 !------------------------------------------------------------------------------!
 
-     USE indices
-     USE transpose_indices
+     USE indices,                                                              &
+         ONLY:  nx
+
+     USE kinds
+
+     USE transpose_indices,                                                    &
+         ONLY:  nyn_x, nys_x, nzb_x, nzt_x
 
      IMPLICIT NONE
 
-     REAL ::  f_inv(nys_x:nyn_x,nzb_x:nzt_x,0:nx)
-     REAL ::  f_out(0:nx,nys_x:nyn_x,nzb_x:nzt_x)
-
-
-     INTEGER ::  i, j, k
-
+     REAL(wp) ::  f_inv(nys_x:nyn_x,nzb_x:nzt_x,0:nx) !: 
+     REAL(wp) ::  f_out(0:nx,nys_x:nyn_x,nzb_x:nzt_x) !: 
+
+
+     INTEGER(iwp) ::  i !: 
+     INTEGER(iwp) ::  j !: 
+     INTEGER(iwp) ::  k !: 
 !
 !-- Rearrange indices of input array in order to make data to be send
@@ -371,16 +396,31 @@
 !------------------------------------------------------------------------------!
 
-    USE cpulog
-    USE indices
-    USE pegrid
-    USE transpose_indices
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, cpu_log_nowait, log_point_s
+
+    USE indices,                                                               &
+        ONLY:  nx, ny
+
+    USE kinds
+
+    USE pegrid,                                                                &
+        ONLY:  collective_wait, comm1dy, comm2d, ierr, MPI_DOUBLE_PRECISION,   &
+               numprocs, pdims, sendrecvcount_xy
+
+    USE transpose_indices,                                                     &
+        ONLY:  nxl_y, nxr_y, nyn_x, nys_x, nzb_x, nzb_y, nzt_x, nzt_y
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, l, ys
-    
-    REAL ::  f_in(0:ny,nxl_y:nxr_y,nzb_y:nzt_y), f_inv(nys_x:nyn_x,nzb_x:nzt_x,0:nx)
-
-    REAL, DIMENSION(nyn_x-nys_x+1,nzb_y:nzt_y,nxl_y:nxr_y,0:pdims(2)-1) ::  work
+    INTEGER(iwp) ::  i  !: 
+    INTEGER(iwp) ::  j  !: 
+    INTEGER(iwp) ::  k  !: 
+    INTEGER(iwp) ::  l  !: 
+    INTEGER(iwp) ::  ys !: 
+
+    REAL(wp) ::  f_in(0:ny,nxl_y:nxr_y,nzb_y:nzt_y)  !: 
+    REAL(wp) ::  f_inv(nys_x:nyn_x,nzb_x:nzt_x,0:nx) !: 
+
+    REAL(wp), DIMENSION(nyn_x-nys_x+1,nzb_y:nzt_y,nxl_y:nxr_y,0:pdims(2)-1) ::  work !: 
 
 
@@ -453,17 +493,32 @@
 !------------------------------------------------------------------------------!
 
-    USE cpulog
-    USE indices
-    USE pegrid
-    USE transpose_indices
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, cpu_log_nowait, log_point_s
+
+    USE indices,                                                               &
+        ONLY:  nnx, nny, nnz, nx, nxl, nxr, nyn, nys, nz
+
+    USE kinds
+
+    USE pegrid,                                                                &
+        ONLY:  collective_wait, comm1dx, comm2d, ierr, MPI_DOUBLE_PRECISION,   &
+               pdims, sendrecvcount_xy
+
+    USE transpose_indices,                                                     &
+        ONLY:  nyn_x, nys_x, nzb_x, nzt_x
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, l, m, xs
-
-    REAL ::  f_in(1:nz,nys:nyn,nxl:nxr), f_inv(nxl:nxr,1:nz,nys:nyn), &
-             f_out(0:nx,nys_x:nyn_x,nzb_x:nzt_x),                     &
-             work(nnx*nny*nnz)
-
+    INTEGER(iwp) ::  i  !: 
+    INTEGER(iwp) ::  j  !: 
+    INTEGER(iwp) ::  k  !: 
+    INTEGER(iwp) ::  l  !: 
+    INTEGER(iwp) ::  m  !: 
+    INTEGER(iwp) ::  xs !: 
+
+    REAL(wp) ::  f_in(1:nz,nys:nyn,nxl:nxr)          !: 
+    REAL(wp) ::  f_inv(nxl:nxr,1:nz,nys:nyn)         !: 
+    REAL(wp) ::  f_out(0:nx,nys_x:nyn_x,nzb_x:nzt_x) !: 
+    REAL(wp) ::  work(nnx*nny*nnz)                   !: 
 #if defined( __parallel )
 
@@ -517,14 +572,20 @@
 !------------------------------------------------------------------------------!
 
-     USE indices
-     USE transpose_indices
+     USE indices,                                                              &
+         ONLY:  ny
+
+     USE kinds
+
+     USE transpose_indices,                                                    &
+         ONLY:  nxl_y, nxr_y, nzb_y, nzt_y
 
      IMPLICIT NONE
 
-     REAL ::  f_in(0:ny,nxl_y:nxr_y,nzb_y:nzt_y)
-     REAL ::  f_inv(nxl_y:nxr_y,nzb_y:nzt_y,0:ny)
-
-
-     INTEGER ::  i, j, k
+     REAL(wp) ::  f_in(0:ny,nxl_y:nxr_y,nzb_y:nzt_y)  !: 
+     REAL(wp) ::  f_inv(nxl_y:nxr_y,nzb_y:nzt_y,0:ny) !: 
+
+     INTEGER(iwp) ::  i !: 
+     INTEGER(iwp) ::  j !: 
+     INTEGER(iwp) ::  k !: 
 
 !
@@ -557,16 +618,31 @@
 !------------------------------------------------------------------------------!
 
-    USE cpulog
-    USE indices
-    USE pegrid
-    USE transpose_indices
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, cpu_log_nowait, log_point_s
+
+    USE indices,                                                               &
+        ONLY:  ny, nz
+
+    USE kinds
+
+    USE pegrid,                                                                &
+        ONLY:  collective_wait, comm1dx, comm2d, ierr, MPI_DOUBLE_PRECISION,   &
+               pdims, sendrecvcount_yz
+
+    USE transpose_indices,                                                     &
+        ONLY:  nxl_y, nxl_z, nxr_y, nxr_z, nyn_z, nys_z, nzb_y, nzt_y
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, l, zs
-    
-    REAL ::  f_inv(nxl_y:nxr_y,nzb_y:nzt_y,0:ny), f_out(nxl_z:nxr_z,nys_z:nyn_z,1:nz)
-
-    REAL, DIMENSION(nxl_z:nxr_z,nzt_y-nzb_y+1,nys_z:nyn_z,0:pdims(1)-1) ::  work
+    INTEGER(iwp) ::  i  !: 
+    INTEGER(iwp) ::  j  !: 
+    INTEGER(iwp) ::  k  !: 
+    INTEGER(iwp) ::  l  !: 
+    INTEGER(iwp) ::  zs !: 
+
+    REAL(wp) ::  f_inv(nxl_y:nxr_y,nzb_y:nzt_y,0:ny) !: 
+    REAL(wp) ::  f_out(nxl_z:nxr_z,nys_z:nyn_z,1:nz) !: 
+
+    REAL(wp), DIMENSION(nxl_z:nxr_z,nzt_y-nzb_y+1,nys_z:nyn_z,0:pdims(1)-1) ::  work !: 
 
 
@@ -637,14 +713,17 @@
 !------------------------------------------------------------------------------!
 
-     USE indices
-     USE transpose_indices
+     USE indices,                                                              &
+         ONLY:  nxl, nxr, nyn, nys, nz
+
+     USE kinds
 
      IMPLICIT NONE
 
-     REAL ::  f_in(1:nz,nys:nyn,nxl:nxr)
-     REAL ::  f_inv(nys:nyn,nxl:nxr,1:nz)
-
-
-     INTEGER ::  i, j, k
+     REAL(wp) ::  f_in(1:nz,nys:nyn,nxl:nxr)  !: 
+     REAL(wp) ::  f_inv(nys:nyn,nxl:nxr,1:nz) !: 
+
+     INTEGER(iwp) ::  i !: 
+     INTEGER(iwp) ::  j !: 
+     INTEGER(iwp) ::  k !: 
 
 !
@@ -677,16 +756,31 @@
 !------------------------------------------------------------------------------!
 
-    USE cpulog
-    USE indices
-    USE pegrid
-    USE transpose_indices
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, cpu_log_nowait, log_point_s
+
+    USE indices,                                                               &
+        ONLY:  nnx, nx, nxl, nxr, nyn, nys, nz
+
+    USE kinds
+
+    USE pegrid,                                                                &
+        ONLY:  collective_wait, comm1dx, comm2d, ierr, MPI_DOUBLE_PRECISION,   &
+               pdims, sendrecvcount_zx
+
+    USE transpose_indices,                                                     &
+        ONLY:  nyn_x, nys_x, nzb_x, nzt_x
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, l, xs
-    
-    REAL ::  f_inv(nys:nyn,nxl:nxr,1:nz), f_out(0:nx,nys_x:nyn_x,nzb_x:nzt_x)
-
-    REAL, DIMENSION(nys_x:nyn_x,nnx,nzb_x:nzt_x,0:pdims(1)-1) ::  work
+    INTEGER(iwp) ::  i  !: 
+    INTEGER(iwp) ::  j  !: 
+    INTEGER(iwp) ::  k  !: 
+    INTEGER(iwp) ::  l  !: 
+    INTEGER(iwp) ::  xs !: 
+
+    REAL(wp) ::  f_inv(nys:nyn,nxl:nxr,1:nz)         !: 
+    REAL(wp) ::  f_out(0:nx,nys_x:nyn_x,nzb_x:nzt_x) !: 
+
+    REAL(wp), DIMENSION(nys_x:nyn_x,nnx,nzb_x:nzt_x,0:pdims(1)-1) ::  work !: 
 
 
@@ -757,14 +851,21 @@
 !------------------------------------------------------------------------------!
 
-     USE indices
-     USE transpose_indices
+     USE indices,                                                              &
+         ONLY:  ny
+
+     USE kinds
+
+     USE transpose_indices,                                                    &
+         ONLY:  nxl_y, nxr_y, nzb_y, nzt_y
 
      IMPLICIT NONE
 
-     REAL ::  f_inv(nxl_y:nxr_y,nzb_y:nzt_y,0:ny)
-     REAL ::  f_out(0:ny,nxl_y:nxr_y,nzb_y:nzt_y)
-
-
-     INTEGER ::  i, j, k
+     REAL(wp) ::  f_inv(nxl_y:nxr_y,nzb_y:nzt_y,0:ny) !: 
+     REAL(wp) ::  f_out(0:ny,nxl_y:nxr_y,nzb_y:nzt_y) !: 
+
+
+     INTEGER(iwp) ::  i !: 
+     INTEGER(iwp) ::  j !: 
+     INTEGER(iwp) ::  k !: 
 
 !
@@ -797,17 +898,31 @@
 !------------------------------------------------------------------------------!
 
-    USE cpulog
-    USE indices
-    USE pegrid
-    USE transpose_indices
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, cpu_log_nowait, log_point_s
+
+    USE indices,                                                               &
+        ONLY:  ny, nz
+
+    USE kinds
+
+    USE pegrid,                                                                &
+        ONLY:  collective_wait, comm1dx, comm2d, ierr, MPI_DOUBLE_PRECISION,   &
+               pdims, sendrecvcount_yz
+
+    USE transpose_indices,                                                     &
+        ONLY:  nxl_y, nxl_z, nxr_y, nxr_z, nyn_z, nys_z, nzb_y, nzt_y
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, l, zs
-    
-    REAL ::  f_in(nxl_z:nxr_z,nys_z:nyn_z,1:nz), f_inv(nxl_y:nxr_y,nzb_y:nzt_y,0:ny)
-
-    REAL, DIMENSION(nxl_z:nxr_z,nzt_y-nzb_y+1,nys_z:nyn_z,0:pdims(1)-1) ::  work
-
+    INTEGER(iwp) ::  i  !: 
+    INTEGER(iwp) ::  j  !: 
+    INTEGER(iwp) ::  k  !: 
+    INTEGER(iwp) ::  l  !: 
+    INTEGER(iwp) ::  zs !: 
+
+    REAL(wp) ::  f_in(nxl_z:nxr_z,nys_z:nyn_z,1:nz)  !: 
+    REAL(wp) ::  f_inv(nxl_y:nxr_y,nzb_y:nzt_y,0:ny) !: 
+
+    REAL(wp), DIMENSION(nxl_z:nxr_z,nzt_y-nzb_y+1,nys_z:nyn_z,0:pdims(1)-1) ::  work !:
 
 !
@@ -881,16 +996,32 @@
 !------------------------------------------------------------------------------!
 
-    USE cpulog
-    USE indices
-    USE pegrid
-    USE transpose_indices
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, cpu_log_nowait, log_point_s
+
+    USE indices,                                                               &
+        ONLY:  nnx, nny, nnz, nxl, nxr, nyn, nys, ny, nz
+
+    USE kinds
+
+    USE pegrid,                                                                &
+        ONLY:  collective_wait, comm1dy, comm2d, ierr, MPI_DOUBLE_PRECISION,   &
+               pdims, sendrecvcount_zyd
+
+    USE transpose_indices,                                                     &
+        ONLY:  nxl_y, nxl_yd, nxr_y, nxr_yd, nzb_y, nzb_yd, nzt_y, nzt_yd
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, l, m, ys
-    
-    REAL ::  f_in(1:nz,nys:nyn,nxl:nxr), f_inv(nys:nyn,nxl:nxr,1:nz), &
-             f_out(0:ny,nxl_yd:nxr_yd,nzb_yd:nzt_yd),                 &
-             work(nnx*nny*nnz)
+    INTEGER(iwp) ::  i  !: 
+    INTEGER(iwp) ::  j  !: 
+    INTEGER(iwp) ::  k  !: 
+    INTEGER(iwp) ::  l  !: 
+    INTEGER(iwp) ::  m  !: 
+    INTEGER(iwp) ::  ys !: 
+
+    REAL(wp) ::  f_in(1:nz,nys:nyn,nxl:nxr)              !: 
+    REAL(wp) ::  f_inv(nys:nyn,nxl:nxr,1:nz)             !: 
+    REAL(wp) ::  f_out(0:ny,nxl_yd:nxr_yd,nzb_yd:nzt_yd) !: 
+    REAL(wp) ::  work(nnx*nny*nnz)                       !: 
 
 #if defined( __parallel )
Index: /palm/trunk/SOURCE/tridia_solver.f90
===================================================================
--- /palm/trunk/SOURCE/tridia_solver.f90	(revision 1319)
+++ /palm/trunk/SOURCE/tridia_solver.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -55,10 +61,15 @@
 !------------------------------------------------------------------------------!
 
-    USE indices
-    USE transpose_indices
+    USE indices,                                                               &
+        ONLY:  nx, ny, nz
+
+    USE kinds
+
+    USE transpose_indices,                                                     &
+        ONLY:  nxl_z, nyn_z, nxr_z, nys_z
 
     IMPLICIT NONE
 
-    REAL, DIMENSION(:,:), ALLOCATABLE ::  ddzuw
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ddzuw !: 
 
     PRIVATE
@@ -79,9 +90,12 @@
     SUBROUTINE tridia_init
 
-       USE arrays_3d,  ONLY:  ddzu_pres, ddzw
+       USE arrays_3d,                                                          &
+           ONLY:  ddzu_pres, ddzw
+
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  k
+       INTEGER(iwp) ::  k !: 
 
        ALLOCATE( ddzuw(0:nz-1,3) )
@@ -109,14 +123,28 @@
 !------------------------------------------------------------------------------!
 
-          USE arrays_3d,  ONLY: tric
-          USE constants
-          USE control_parameters
-          USE grid_variables
+          USE arrays_3d,                                                       &
+              ONLY:  tric
+
+          USE constants,                                                       &
+              ONLY:  pi
+
+          USE control_parameters,                                              &
+              ONLY:  ibc_p_b, ibc_p_t
+
+          USE grid_variables,                                                  &
+              ONLY:  dx, dy
+
+
+          USE kinds
 
           IMPLICIT NONE
 
-          INTEGER ::  i, j, k, nnxh, nnyh
-
-          REAL    ::  ll(nxl_z:nxr_z,nys_z:nyn_z)
+          INTEGER(iwp) ::  i    !: 
+          INTEGER(iwp) ::  j    !: 
+          INTEGER(iwp) ::  k    !: 
+          INTEGER(iwp) ::  nnxh !: 
+          INTEGER(iwp) ::  nnyh !: 
+
+          REAL(wp)    ::  ll(nxl_z:nxr_z,nys_z:nyn_z) !: 
           !$acc declare create( ll )
 
@@ -201,14 +229,21 @@
 !------------------------------------------------------------------------------!
 
-          USE arrays_3d,  ONLY: tri
-          USE control_parameters
+          USE arrays_3d,                                                       & 
+              ONLY:  tri
+
+          USE control_parameters,                                              &
+              ONLY:  ibc_p_b, ibc_p_t
+
+          USE kinds
 
           IMPLICIT NONE
 
-          INTEGER ::  i, j, k
-
-          REAL    ::  ar(nxl_z:nxr_z,nys_z:nyn_z,1:nz)
-
-          REAL, DIMENSION(nxl_z:nxr_z,nys_z:nyn_z,0:nz-1)   ::  ar1
+          INTEGER(iwp) ::  i !: 
+          INTEGER(iwp) ::  j !: 
+          INTEGER(iwp) ::  k !: 
+
+          REAL(wp)     ::  ar(nxl_z:nxr_z,nys_z:nyn_z,1:nz) !: 
+
+          REAL(wp), DIMENSION(nxl_z:nxr_z,nys_z:nyn_z,0:nz-1)   ::  ar1 !: 
           !$acc declare create( ar1 )
 
@@ -275,15 +310,23 @@
 !------------------------------------------------------------------------------!
 
-          USE arrays_3d,  ONLY: tri
-          USE control_parameters
+          USE arrays_3d,                                                       &
+              ONLY:  tri
+
+          USE control_parameters,                                              &
+              ONLY:  ibc_p_b, ibc_p_t
+
+          USE kinds
 
           IMPLICIT NONE
 
-          INTEGER ::  i, j, jj, k
-
-          REAL    ::  ar(nxl_z:nxr_z,nys_z:nyn_z,1:nz)
+          INTEGER(iwp) ::  i  !: 
+          INTEGER(iwp) ::  j  !: 
+          INTEGER(iwp) ::  jj !: 
+          INTEGER(iwp) ::  k  !: 
+
+          REAL(wp)     ::  ar(nxl_z:nxr_z,nys_z:nyn_z,1:nz) !: 
 
           !$acc declare create( ar1 )
-          REAL, DIMENSION(nxl_z:nxr_z,nys_z:nyn_z,0:nz-1)   ::  ar1
+          REAL(wp), DIMENSION(nxl_z:nxr_z,nys_z:nyn_z,0:nz-1) ::  ar1 !: 
 
 !
@@ -350,10 +393,14 @@
 !------------------------------------------------------------------------------!
 
-          USE arrays_3d,  ONLY: tri, tric
+          USE arrays_3d,                                                       & 
+              ONLY:  tri, tric
+
+          USE kinds
 
           IMPLICIT NONE
 
-          INTEGER ::  i, j, k
-
+          INTEGER(iwp) ::  i !: 
+          INTEGER(iwp) ::  j !: 
+          INTEGER(iwp) ::  k !: 
 !
 !--       Splitting
@@ -398,17 +445,28 @@
 !------------------------------------------------------------------------------!
 
-       USE arrays_3d
-       USE control_parameters
-
-       USE pegrid
+       USE arrays_3d,                                                          &
+           ONLY:  ddzu_pres, ddzw
+
+       USE control_parameters,                                                 &
+           ONLY:  ibc_p_b, ibc_p_t
+
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k, nnyh, nx, ny, omp_get_thread_num, tn
-
-       REAL    ::  ddx2, ddy2
-
-       REAL, DIMENSION(0:nx,1:nz)     ::  ar
-       REAL, DIMENSION(5,0:nx,0:nz-1) ::  tri_for_1d
+       INTEGER(iwp) ::  i                  !: 
+       INTEGER(iwp) ::  j                  !: 
+       INTEGER(iwp) ::  k                  !: 
+       INTEGER(iwp) ::  nnyh               !: 
+       INTEGER(iwp) ::  nx                 !: 
+       INTEGER(iwp) ::  ny                 !: 
+       INTEGER(iwp) ::  omp_get_thread_num !: 
+       INTEGER(iwp) ::  tn                 !: 
+
+       REAL(wp)     ::  ddx2 !: 
+       REAL(wp)     ::  ddy2 !: 
+
+       REAL(wp), DIMENSION(0:nx,1:nz)     ::  ar         !: 
+       REAL(wp), DIMENSION(5,0:nx,0:nz-1) ::  tri_for_1d !: 
 
 
@@ -465,15 +523,23 @@
 !------------------------------------------------------------------------------!
 
-          USE constants
+          USE constants,                                                       &
+              ONLY:  pi
+
+          USE kinds
 
           IMPLICIT NONE
 
-          INTEGER ::  i, j, k, nnxh
-          REAL    ::  a, c
-
-          REAL, DIMENSION(0:nx) ::  l
+          INTEGER(iwp) ::  i    !: 
+          INTEGER(iwp) ::  j    !: 
+          INTEGER(iwp) ::  k    !: 
+          INTEGER(iwp) ::  nnxh !: 
+
+          REAL(wp)     ::  a !: 
+          REAL(wp)     ::  c !: 
+
+          REAL(wp), DIMENSION(0:nx) ::  l !: 
 
 #if defined( __intel11 )
-          REAL, DIMENSION(5,0:nx,0:nz-1) ::  tri_for_1d
+          REAL(wp), DIMENSION(5,0:nx,0:nz-1) ::  tri_for_1d !: 
 #endif
 
@@ -533,8 +599,9 @@
           IMPLICIT NONE
 
-          INTEGER ::  i, k
+          INTEGER(iwp) ::  i !: 
+          INTEGER(iwp) ::  k !: 
 
 #if defined( __intel11 )
-          REAL, DIMENSION(5,0:nx,0:nz-1) ::  tri_for_1d
+          REAL(wp), DIMENSION(5,0:nx,0:nz-1) ::  tri_for_1d !: 
 #endif
 
@@ -563,9 +630,10 @@
           IMPLICIT NONE
 
-          INTEGER ::  i, k
-
-          REAL, DIMENSION(0:nx,nz)       ::  ar
-          REAL, DIMENSION(0:nx,0:nz-1)   ::  ar1
-          REAL, DIMENSION(5,0:nx,0:nz-1) ::  tri_for_1d
+          INTEGER(iwp) ::  i !: 
+          INTEGER(iwp) ::  k !: 
+
+          REAL(wp), DIMENSION(0:nx,nz)       ::  ar         !: 
+          REAL(wp), DIMENSION(0:nx,0:nz-1)   ::  ar1        !: 
+          REAL(wp), DIMENSION(5,0:nx,0:nz-1) ::  tri_for_1d !: 
 
 !
Index: /palm/trunk/SOURCE/user_3d_data_averaging.f90
===================================================================
--- /palm/trunk/SOURCE/user_3d_data_averaging.f90	(revision 1319)
+++ /palm/trunk/SOURCE/user_3d_data_averaging.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! -----------------
-! 
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -39,13 +43,19 @@
 
     USE control_parameters
+
     USE indices
+
+    USE kinds
+
     USE user
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  mode, variable
+    CHARACTER (LEN=*) ::  mode    !: 
+    CHARACTER (LEN=*) :: variable !: 
 
-    INTEGER ::  i, j, k
-
+    INTEGER(iwp) ::  i !: 
+    INTEGER(iwp) ::  j !: 
+    INTEGER(iwp) ::  k !: 
 
     IF ( mode == 'allocate' )  THEN
Index: /palm/trunk/SOURCE/user_actions.f90
===================================================================
--- /palm/trunk/SOURCE/user_actions.f90	(revision 1319)
+++ /palm/trunk/SOURCE/user_actions.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-!
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -34,10 +38,4 @@
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
-!
-! 258 2009-03-13 12:36:03Z heinze
-! Output of messages replaced by message handling routine.
 !
 ! 211 2008-11-11 04:46:24Z raasch
@@ -66,15 +64,24 @@
 
        USE control_parameters
+
        USE cpulog
+
        USE indices
+
+       USE kinds
+
        USE pegrid
+
        USE user
+
        USE arrays_3d
 
        IMPLICIT NONE
 
-       CHARACTER (LEN=*) ::  location
-
-       INTEGER ::  i, j, k
+       CHARACTER (LEN=*) ::  location !: 
+
+       INTEGER(iwp) ::  i !: 
+       INTEGER(iwp) ::  j !: 
+       INTEGER(iwp) ::  k !: 
 
        CALL cpu_log( log_point(24), 'user_actions', 'start' )
@@ -165,4 +172,5 @@
 
        USE control_parameters
+       USE kinds
        USE pegrid
        USE user
@@ -172,6 +180,7 @@
        CHARACTER (LEN=*) ::  location
 
-       INTEGER ::  i, idum, j
-
+       INTEGER(iwp) ::  i
+       INTEGER(iwp) ::  idum
+       INTEGER(iwp) ::  j
 
 !
Index: /palm/trunk/SOURCE/user_additional_routines.f90
===================================================================
--- /palm/trunk/SOURCE/user_additional_routines.f90	(revision 1319)
+++ /palm/trunk/SOURCE/user_additional_routines.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! -----------------
-! 
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -37,4 +41,6 @@
 !------------------------------------------------------------------------------!
 
+    USE kinds
+
     USE user
 
Index: /palm/trunk/SOURCE/user_check_data_output.f90
===================================================================
--- /palm/trunk/SOURCE/user_check_data_output.f90	(revision 1319)
+++ /palm/trunk/SOURCE/user_check_data_output.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! -----------------
-! 
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -40,9 +44,12 @@
 !------------------------------------------------------------------------------!
 
+    USE kinds
+
     USE user
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  unit, variable
+    CHARACTER (LEN=*) ::  unit     !: 
+    CHARACTER (LEN=*) ::  variable !:
 
 
Index: /palm/trunk/SOURCE/user_check_data_output_pr.f90
===================================================================
--- /palm/trunk/SOURCE/user_check_data_output_pr.f90	(revision 1319)
+++ /palm/trunk/SOURCE/user_check_data_output_pr.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! -----------------
-! 
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -41,16 +45,24 @@
 
     USE arrays_3d
+
     USE indices
+
+    USE kinds
+
     USE netcdf_control
+
     USE profil_parameter
+
     USE statistics
+
     USE user
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  unit, variable
+    CHARACTER (LEN=*) ::  unit     !: 
+    CHARACTER (LEN=*) ::  variable !: 
 
-    INTEGER ::  index, var_count
-
+    INTEGER(iwp) ::  user_pr_index !: 
+    INTEGER(iwp) ::  var_count     !: 
 
     SELECT CASE ( TRIM( variable ) )
@@ -62,13 +74,13 @@
 !--    to be performed have to be added in routine user_statistics.
 !--    The quantities are (internally) identified by a user-profile-number
-!--    (see variable "index" below). The first user-profile must be assigned
+!--    (see variable "user_pr_index" below). The first user-profile must be assigned
 !--    the number "pr_palm+1", the second one "pr_palm+2", etc. The respective
 !--    user-profile-numbers have also to be used in routine user_statistics!
 !       CASE ( 'u*v*' )                      ! quantity string as given in
 !                                            ! data_output_pr_user
-!          index = pr_palm + 1
-!          dopr_index(var_count)  = index    ! quantities' user-profile-number
+!          user_pr_index = pr_palm + 1
+!          dopr_index(var_count)  = user_pr_index    ! quantities' user-profile-number
 !          dopr_unit(var_count)   = 'm2/s2'  ! quantity unit
-!          hom(:,2,index,:)       = SPREAD( zu, 2, statistic_regions+1 )
+!          hom(:,2,user_pr_index,:)       = SPREAD( zu, 2, statistic_regions+1 )
 !                                            ! grid on which the quantity is
 !                                            ! defined (use zu or zw)
